"use strict";

{
	const C3 = self.C3;
	C3.Plugins.Lagged_API.Acts =
	{
		ShowAd(urlkey,thumbnail)
		{
			console.log('LaggedAPI: show an ad, is playing: ', this._adPlaying);
			if(!this._adPlaying){
				var selfy=this;

				selfy.Trigger(C3.Plugins.Lagged_API.Cnds.PauseGame);
				selfy._adPlaying=true;

				console.log("offline mode: ", this._offlineMode);

				if(this._adcnt<45&&!this._offlineMode){
					selfy.Trigger(C3.Plugins.Lagged_API.Cnds.ResumeGame);
					selfy._adPlaying=false;
					return true;
				}

				try{

					self["LaggedAPI"]["APIAds"]["show"]('interstitial',urlkey,thumbnail,function(response) {
						selfy._adcnt=-45;
						selfy._adPlaying=false;
						selfy.Trigger(C3.Plugins.Lagged_API.Cnds.ResumeGame);
						console.log('c3 plugin response: ad finished', response);
					});


				// LaggedAPI['APIAds'].show('interstitial',urlkey,thumbnail,function(response) {
				// 	self._adcnt=-45;
				//   if(response.success) {
				//     console.log('ad done');
				//   }else {
				//     console.log(response.errormsg);
				//   }
				// 	self._adPlaying=false;
				// 	self.Trigger(C3.Plugins.Lagged_API.Cnds.ResumeGame);
				// });
				}catch(e){
					console.log(e);
					selfy.Trigger(C3.Plugins.Lagged_API.Cnds.ResumeGame);
					selfy._adPlaying=false;
				}
			}
		},
		ShowAwards()
		{
			try{
				//LaggedAPI['Achievements'].show();
				self["LaggedAPI"]['Achievements']['show']();
			}catch(e){
			console.log('error: open achievement');
			}
		},
		InitGame(gameid)
		{

			try{
				self["LaggedAPI"]["init"](gameid,'lagdevaF3001');
				if(this._offlineMode){
				console.log('LaggedAPI: init game with id ', gameid)
				}
			}catch(e){
				console.log(e);
			}

			// try{
			// 	LaggedAPI.init(gameid,'lagdevaF3001');
			// 	if(this._offlineMode){
			// 	console.log('LaggedAPI: init game with id ', gameid)
			// 	}
			// }catch(e){
			// 	console.log(e);
			// }
		},
		SaveAchievement(award)
		{
			try{
			if(this._savedAchs.indexOf(award) > -1){

				console.log('LaggedAPI: achievement already saved, skip ', award);

			}else{
			var ach_numb=[];
			ach_numb.push(award);
			this._savedAchs.push(award);

			self["LaggedAPI"]["Achievements"]["save"](ach_numb, function(response) {
				console.log(response);
			});


			// LaggedAPI['Achievements'].save(ach_numb, function(response) {
			// if(response.success) {
			// console.log('achievement saved')
			// // note that we could still have a failure errorcode here when the player
			// // already has an achievement
			// }else {
			// console.log(response.errormsg);
			// }
			// });

			if(this._offlineMode){
				console.log('LaggedAPI: save achievement ', award);
			}
			}
			}catch(e){
				console.log(e);
			}
		},
		SaveScore(score,board)
		{

			try{
			var boardinfo={};
			boardinfo['score']=score;
			boardinfo['board']=board;

			self["LaggedAPI"]["Scores"]["save"](boardinfo, function(response) {
				console.log(response);
			});


			// LaggedAPI['Scores'].save(boardinfo, function(response) {
			// if(response.success) {
			// console.log('high score saved')
			// }else {
			// console.log(response.errormsg);
			// }
			// });

			}catch(e){
				console.log(e);
			}

			if(this._offlineMode){
			console.log('LaggedAPI: Save high score: ', score);
			console.log('LaggedAPI: Save to board id: ', board)
			}

		},
		ViewWalkthrough(jwid)
		{
			console.log("api play walkthrough jwid: ", jwid)
			try{
			window.parent.viewPlaythrough(jwid);
			}catch(e){
				try{
			    var postmsg='walkthrough|'+jwid;
					window.parent.postMessage(postmsg,'*');
				}catch(e){
					console.log(e);
				}
			console.log(e);
			}

		}
	};
}
